# LeetCode Solution 1 : Two Sum

Given an array of integers, return **indices** of the two numbers such that they add up to a specific target.

You may assume that each input would have **exactly** one solution, and you may not use the **same** element twice.

**Example:**

```
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].
```

## Solution

### Approach #1 (Brute Force) [Accepted]

The brute force approach is simple. Loop through each element **x** and find if there is another value that equals to *target* − ** x**.

```
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
for (int i = 0; i < nums.size(); ++i) {
for (int j = i + 1; j < nums.size(); ++j) {
if (target - nums[i] == nums[j]) {
return vector<int> {i, j};
}
}
}
throw invalid_argument("No two sum solution");
}
};
```

**Complexity Analysis**

- Time complexity :
**O(n²)**. For each element, we try to find its complement by looping through the rest of array which takes**O(n)O(n)**time. Therefore, the time complexity is**O(n²)** - Space complexity :
**O(1)**

### Approach #2 (Two-pass Hash Table) [Accepted]

To improve our run time complexity, we need a more efficient way to check if the complement exists in the array. If the complement exists, we need to look up its index. What is the best way to maintain a mapping of each element in the array to its index? A hash table.

We reduce the look up time from **O(n)** to **O(1)** by trading space for speed. A hash table is built exactly for this purpose, it supports fast look up in near constant time. I say "near" because if a collision occurred, a look up could degenerate to **O(n)** time. But look up in hash table should be amortized **O(1)** time as long as the hash function was chosen carefully.

A simple implementation uses two iterations. In the first iteration, we add each element's value and its index to the table. Then, in the second iteration we check if each element's complement (**target - nums[i]**) exists in the table. Beware that the complement must not be **nums[i]** itself!

```
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
unordered_map<int, int> map;
for (int i = 0; i < nums.size(); ++i) {
map.insert({ nums[i], i });
}
for (int j = 0; j < nums.size(); ++j) {
int complement = target - nums[j];
if (map.count(complement) && map.find(complement)->second != j) {
return vector<int> { j, map.find(complement)->second };
}
}
throw invalid_argument("No two sum solution");
}
};
```

**Complexity Analysis:**

- Time complexity :
**O(n)**. We traverse the list containing nn elements exactly twice. Since the hash table reduces the look up time to**O(1)**, the time complexity is**O(n)**. - Space complexity :
**O(n)**. The extra space required depends on the number of items stored in the hash table, which stores exactly**n**elements.

### Approach #3 (One-pass Hash Table) [Accepted]

It turns out we can do it in one-pass. While we iterate and inserting elements into the table, we also look back to check if current element's complement already exists in the table. If it exists, we have found a solution and return immediately.

```
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
unordered_map<int, int> map;
for (int i = 0; i < nums.size(); ++i) {
int complement = target - nums[i];
if (map.count(complement)) {
return vector<int> { map.find(complement)->second, i };
}
map.insert({ nums[i], i });
}
throw invalid_argument("No two sum solution");
}
};
```

**Complexity Analysis:**

- Time complexity :
**O(n)**. We traverse the list containing**n**elements only once. Each look up in the table costs only**O(1)**time. - Space complexity :
**O(n)**. The extra space required depends on the number of items stored in the hash table, which stores at most**n**elements.